ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.62
Committed: Mon Sep 10 18:30:30 2007 UTC (16 years, 8 months ago) by root
Branch: MAIN
CVS Tags: rel-2_2, rel-2_3, rel-2_32
Changes since 1.61: +4 -1 lines
Log Message:
- note to self: all forms of cede need PUTBACK
  as any other fucntion modifying the stack.
- the beginning of tag support
- just for fun tag soem buildings in scorn and watch the database change
- do not install world-precomposed, this saves a lot of traffic, scanning
  and other things.
- add tag field to every object in the editor.

File Contents

# Content
1 #!@PERL@
2
3 use strict;
4
5 my $prefix = "@prefix@";
6 my $exec_prefix = "@exec_prefix@";
7 my $datarootdir = "@datarootdir@";
8 my $DATADIR = "@datadir@/@PACKAGE@";
9
10 my $CONVERT = "@CONVERT@";
11 #my $IDENTIFY = "@IDENTIFY@";
12 my $OPTIPNG = "@OPTIPNG@";
13 my $RSYNC = "@RSYNC@";
14 my $PNGNQ = "@PNGNQ@";
15
16 use Getopt::Long;
17 use Coro::Event;
18 use AnyEvent;
19 use IO::AIO ();
20 use File::Temp;
21 use Crossfire;
22 use Coro;
23 use Coro::AIO;
24 use Coro::Util;
25 use POSIX ();
26 use Carp;
27 use Coro::Channel;
28 use Coro::Storable; $Storable::canonical = 1;
29
30 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
31
32 sub usage {
33 warn <<EOF;
34 Usage: cfutil [-v] [-q] [--force] [--cache]
35 [--install-arch path]
36 [--install-maps maps]
37 [--print-statedir]
38 [--print-confdir]
39 [--print-datadir]
40 [--print-libdir]
41 [--print-bindir]
42 EOF
43 exit 1;
44 }
45
46 my $VERBOSE = 1;
47 my $CACHE = 0;
48 my $FORCE;
49 my $TMPDIR = "/tmp/cfutil$$~";
50 my $TMPFILE = "aaaa0";
51
52 our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66 );
67
68 END { system "rm", "-rf", $TMPDIR }
69
70 Event->signal (signal => "INT", cb => sub { exit 1 });
71 Event->signal (signal => "TERM", cb => sub { exit 1 });
72
73 mkdir $TMPDIR, 0700
74 or die "$TMPDIR: $!";
75
76 sub fork_sub(&) {
77 my ($cb) = @_;
78
79 if (my $pid = fork) {
80 my $current = $Coro::current;
81 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
82 Coro::schedule;
83 } else {
84 eval { $cb->() };
85 POSIX::_exit 0 unless $@;
86 warn $@;
87 POSIX::_exit 1;
88 }
89 }
90
91 sub inst_maps($) {
92 my (undef, $path) = @_;
93
94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
95
96 if (!-f "$path/regions") {
97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
98 exit 1 unless $FORCE;
99 }
100
101 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
102 "$path/.", "$DATADIR/maps/.",
103 "--exclude", "CVS", "--exclude", "/world-precomposed",
104 "--delete", "--delete-excluded"
105 and die "map installation failed.\n";
106
107 print "maps installed successfully.\n";
108 }
109
110 {
111 our %ANIMINFO;
112 our %FACEINFO;
113 our %RESOURCE;
114 our @ARC;
115 our %ARC;
116 our $TRS;
117 our $NFILE;
118 our $PATH;
119
120 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
121
122 our $c_arc = new Coro::Channel;
123 our $c_trs = new Coro::Channel;
124 our $c_res = new Coro::Channel;
125
126 our @c_png;
127
128 sub commit_png($$$) {
129 my ($name, $data, $T) = @_;
130
131 $FACEINFO{$name}{"data$T"} = $data;
132 }
133
134 sub process_png {
135 while (@c_png) {
136 my ($path, $delete) = @{pop @c_png};
137
138 my $png;
139 aio_lstat $path;
140 my ($size, $mtime) = (stat _)[7,9];
141
142 if (0 > aio_load $path, $png) {
143 warn "$path: $!, skipping.\n";
144 next;
145 }
146
147 my $stem = $path;
148 my $T;
149
150 if ($stem =~ s/\.32x32\.png~?$//) {
151 $T = 32;
152 } elsif ($stem =~ s/\.64x64\.png~?$//) {
153 $T = 64;
154 } else {
155 warn "$path: weird filename, skipping.\n";
156 next;
157 }
158
159 # quickly extract width and height of the (necessarily PNG) image
160 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
161 warn "$path: not a recognized png file, skipping.\n";
162 next;
163 }
164
165 my ($w, $h) = unpack "NN", $1;
166
167 if ($w < $T || $h < $T) {
168 warn "$path: too small ($w $h), skipping.\n";
169 next;
170 }
171
172 if ($w % $T || $h % $T) {
173 warn "$path: weird png size ($w $h), skipping.\n";
174 next;
175 }
176
177 (my $base = $stem) =~ s/^.*\///;
178
179 my $fi = $FACEINFO{$base};
180 unless ($fi) {
181 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
182 #next;
183 }
184
185 my $arc = $fi->{arc} || { };
186
187 unless ($path =~ /~$/) {
188 # possibly enlarge
189 if (0 > aio_stat "$stem.64x64.png") {
190 my $other = "$stem.64x64.png~";
191
192 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
193 fork_sub {
194 my $CROP;
195 my $SRC = "png:\Q$path\E";
196
197 my $is_floor = $arc->{is_floor};
198 my $is_wall = 0;
199
200 my ($wall_pfx, $wall_dir, $wall_sfx);
201
202 if (
203 !$is_floor
204 && !$arc->{alive}
205 && $arc->{move_block} eq "all"
206 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
207 ) {
208 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
209
210 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
211 $is_wall = 1;
212 }
213 }
214
215 if ($is_wall || $is_floor) {
216 # add a 4px border and add other images around it
217 $CROP = "-shave 8x8 +repage";
218
219 $w += 8;
220 $h += 8;
221
222 $SRC = "-size ${w}x${h} xc:transparent";
223 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
224
225 # 8 surrounding images
226 for (
227 # x y b r0 r1
228 [-1, -1, 0, 6],
229 [ 0, -1, 1, 10, 14],
230 [+1, -1, 0, 12],
231
232 [-1, 0, 8, 5, 7],
233 #
234 [+1, 0, 2, 5, 13],
235
236 [-1, +1, 0, 3],
237 [ 0, +1, 4, 10, 11],
238 [+1, +1, 0, 9],
239 ) {
240 my ($x, $y, $d, $r0, $r1) = @$_;
241
242 my $tile = $is_floor ? $path
243 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
244 : die;
245
246 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
247 "\Q$tile",
248 $x * ($w - 8) + 4,
249 $y * ($h - 8) + 4;
250 }
251 }
252
253 system "convert -depth 8 $SRC rgba:-"
254 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
255 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
256 and die "convert/cfhq2xa pipeline error: status $? ($!)";
257 system $OPTIPNG, "-i0", "-q", "$other~";
258 die "$other~ has zero size, aborting." unless -s "$other~";
259 rename "$other~", $other;
260 };
261 }
262
263 push @c_png, [$other, !$CACHE];
264 }
265
266 # possibly scale down
267 if (0 > aio_stat "$stem.32x32.png") {
268 my $other = "$stem.32x32.png~";
269
270 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
271 fork_sub {
272 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
273 system $OPTIPNG, "-i0", "-q", "$other~";
274
275 # reduce smoothfaces >10000 bytes
276 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
277 my $ncolor = 256;
278 while () {
279 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
280 system $OPTIPNG, "-i0", "-q", "$other~~";
281 last if 10000 > -s "$other~~";
282 $ncolor = int $ncolor * 0.9;
283 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
284 }
285
286 printf "reduced %s from %d to %d bytes using %d colours.\n",
287 $other, -s "$other~", -s "$other~~", $ncolor
288 if $VERBOSE >= 2;
289 rename "$other~~", "$other~";
290 }
291
292 die "$other~ has zero size, aborting." unless -s "$other~";
293 rename "$other~", $other;
294 };
295 }
296
297 #warn "scaled down $path to $other\n";#d#
298 push @c_png, [$other, !$CACHE];
299 }
300 }
301
302 (my $face = $stem) =~ s/^.*\///;
303
304 # split all bigfaces, but avoid smoothfaces (*_S)
305 if (($w > $T || $h > $T) && $face !~ /_S\./) {
306 # split
307 my @tile;
308 for my $x (0 .. (int $w / $T) - 1) {
309 for my $y (0 .. (int $h / $T) - 1) {
310 my $file = "$path+$x+$y~";
311 aio_lstat $file;
312 push @tile, [$x, $y, $file, (stat _)[9]];
313 }
314 }
315
316 my $mtime = (lstat $path)[9];
317 my @todo = grep { $_->[3] <= $mtime } @tile;
318 if (@todo) {
319 fork_sub {
320 open my $convert, "|-", $CONVERT,
321 "png:-",
322 (map {
323 (
324 "(",
325 "+clone",
326 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
327 "+repage",
328 -quality => "00",
329 -write => "png32:$_->[2]~",
330 "+delete",
331 ")",
332 )
333 } @todo),
334 "null:";
335
336 binmode $convert;
337 print $convert $png;
338 close $convert;
339
340 # pass 2, optimise, and rename
341 for (@todo) {
342 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
343 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
344 rename "$_->[2]~", $_->[2];
345 }
346 };
347 }
348
349 for (@tile) {
350 my ($x, $y, $file) = @$_;
351 my $tile;
352
353 if (0 > aio_load $file, $tile) {
354 die "$path: unable to read tile +$x+$y, aborting.\n";
355 }
356 IO::AIO::aio_unlink $file unless $CACHE;
357 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
358 }
359 } else {
360 # use as-is (either small, use smooth)
361 commit_png $face, $png, $T;
362 }
363
364 aio_unlink $path if $delete;
365 }
366 }
367
368 sub process_arc {
369 while (my $job = $c_arc->get) {
370 my ($dir, $file) = @$job;
371
372 my $arc;
373 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
374
375 my $arc = read_arch "$dir/$file";
376 for my $o (values %$arc) {
377 push @ARC, $o;
378 for (my $m = $o; $m; $m = $m->{more}) {
379 $ARC{$m->{_name}} = $m;
380 }
381
382 $o->{editor_folder} = $dir;
383
384 my $visibility = delete $o->{visibility};
385 my $magicmap = delete $o->{magicmap};
386
387 # find upper left corner :/
388 # omg, this is sooo broken
389 my ($dx, $dy);
390 for (my $o = $o; $o; $o = $o->{more}) {
391 $dx = $o->{x} if $o->{x} < $dx;
392 $dy = $o->{y} if $o->{y} < $dy;
393 }
394
395 for (my $o = $o; $o; $o = $o->{more}) {
396 my $x = $o->{x} - $dx;
397 my $y = $o->{y} - $dy;
398
399 my $ext = $x|$y ? "+$x+$y" : "";
400
401 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
402
403 $visibility = delete $o->{visibility} if exists $o->{visibility};
404 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
405
406 my $anim = delete $o->{anim};
407
408 if ($anim) {
409 # possibly add $ext to the animation name to avoid
410 # the need to specify archnames for all parts
411 # of a multipart archetype.
412 $o->{animation} = "$o->{_name}";
413 my $facings = 1;
414 my @frames;
415
416 for (@$anim) {
417 if (/^facings\s+(\d+)/) {
418 $facings = $1*1;
419 } elsif (/^blank.x11$|^empty.x11$/) {
420 push @frames, $_;
421 } else {
422 push @frames, "$_$ext";
423 }
424 }
425
426 $ANIMINFO{$o->{animation}} = {
427 facings => $facings,
428 frames => \@frames,
429 };
430 }
431
432 for ($o->{face} || (), @{$anim || []}) {
433 next if /^facings\s/;
434
435 my $face = $_;
436 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
437
438 my $info = $FACEINFO{$face} ||= { };
439 $info->{arc} = $o;
440
441 next if $face =~ /^blank.x11$|^empty.x11$/;
442
443 $info->{visibility} = $visibility if defined $visibility;
444 $info->{magicmap} = $magicmap if defined $magicmap;
445 }
446
447 if (my $smooth = delete $o->{smoothface}) {
448 my %kv = split /\s+/, $smooth;
449 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
450 while (my ($face, $smooth) = each %kv) {
451 $FACEINFO{$smooth}{arc} = $o;
452
453 $FACEINFO{$face}{smooth} = $smooth;
454 $FACEINFO{$face}{smoothlevel} = $level;
455 }
456 }
457 }
458 }
459 }
460 }
461
462 sub process_trs {
463 while (my $job = $c_trs->get) {
464 my ($dir, $file) = @$job;
465 my $path = "$dir/$file";
466
467 my $trs;
468 if (0 > aio_load $path, $trs) {
469 warn "$path: $!, skipping.\n";
470 next;
471 }
472
473 $TRS .= $trs;
474 }
475 }
476
477 my %FILECACHE;
478
479 sub load_cached($;$) {
480 unless (exists $FILECACHE{$_[0]}) {
481 my $data;
482 if (0 < aio_load $_[0], $data) {
483 if ($_[1]) {
484 $data = eval { $_[1]->($data) };
485 warn "$_[0]: $@" if $@;
486 }
487 }
488
489 $FILECACHE{$_[0]} = $data;
490 }
491
492 $FILECACHE{$_[0]}
493 }
494
495 sub process_res {
496 while (my $job = $c_res->get) {
497 my ($dir, $file, $type) = @$job;
498
499 my $data;
500 aio_load "$dir/$file", $data;
501
502
503 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
504
505 utf8::decode $dir;
506 utf8::decode $file;
507
508 # a meta file for resources is now mandatory
509 unless (exists $meta->{$file}) {
510 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
511 next;
512 }
513
514 $meta = {
515 %{ $meta->{"" } || {} },
516 %{ $meta->{$file} || {} },
517 };
518
519 if ($meta->{license} =~ s/^#//) {
520 $meta->{license} = ({
521 "pd" => "Public Domain",
522 "gpl" => "GNU General Public License, version 3.0 or any later",
523 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
524 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
525 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
526 })->{$meta->{license}}
527 || warn "$dir/$file: license tag '$meta->{license}' not found.";
528 }
529
530 $file =~ s/\.res$//;
531 $file =~ s/\.(ogg|wav|jpg|png)$//;
532
533 substr $dir, 0, 1 + length $PATH, "";
534
535 $RESOURCE{"$dir/$file"} = {
536 type => (delete $meta->{type}) || $type,
537 data => $data,
538 %$meta ? (meta => $meta) : (),
539 };
540 }
541 }
542
543 sub find_files;
544 sub find_files {
545 my ($path) = @_;
546
547 IO::AIO::aioreq_pri 4;
548 IO::AIO::aio_scandir $path, 4, sub {
549 my ($dirs, $nondirs) = @_;
550
551 find_files "$path/$_"
552 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
553
554 my $dir = $path;
555 substr $dir, 0, 1 + length $PATH, "";
556
557 for my $file (@$nondirs) {
558 if ($dir =~ /^music(?:\/|$)/) {
559 $c_res->put ([$path, $file, 3]) # FT_MUSIC
560 if $file =~ /\.(ogg)$/;
561
562 } elsif ($dir =~ /^sound(?:\/|$)/) {
563 $c_res->put ([$path, $file, 5]) # FT_SOUND
564 if $file =~ /\.(wav|ogg)$/;
565
566 } elsif ($dir =~ /^res(?:\/|$)/) {
567 $c_res->put ([$path, $file, 0]) # FT_FACE
568 if $file =~ /\.(jpg|png)$/;
569 $c_res->put ([$path, $file, 7]) # FT_RSRC
570 if $file =~ /\.(res)$/;
571
572 } elsif ($file =~ /\.png$/) {
573 push @c_png, ["$path/$file", 0];
574
575 } elsif ($file =~ /\.trs$/) {
576 $c_trs->put ([$path, $file]);
577
578 } elsif ($file =~ /\.arc$/) {
579 $c_arc->put ([$path, $file]);
580
581 } else {
582 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
583 }
584 }
585 };
586 }
587
588 sub inst_arch($) {
589 my (undef, $path) = @_;
590
591 $PATH = $path;
592
593 print "\n",
594 "Installing '$path' to '$DATADIR'\n",
595 "\n",
596 "This can take a long time if you run this\n",
597 "for the first time or do not use --cache.\n",
598 "\n",
599 "Unless you run verbosely, all following warning\n",
600 "or error messages indicate serious problems.\n",
601 "\n";
602
603 if (!-d "$path/treasures") {
604 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
605 exit 1 unless $FORCE;
606 }
607
608 print "scanning files...\n" if $VERBOSE;
609
610 find_files $path;
611
612 my @a_arc = map +(async \&process_arc), 1..2;
613 my @a_res = map +(async \&process_res), 1..2;
614 my @a_trs = map +(async \&process_trs), 1..2;
615
616 IO::AIO::flush;
617
618 $c_res->put (undef) for @a_res;
619 $c_arc->put (undef) for @a_arc;
620 $c_trs->put (undef) for @a_trs;
621
622 print "start file scan, arc, res processing...\n" if $VERBOSE;
623
624 $_->join for @a_arc; # need to parse all archetypes before png processing
625
626 print "end arc, start png processing...\n" if $VERBOSE;
627
628 # four png crunchers work fine for my 2x smp machine
629 my @a_png = map +(async \&process_png), 1..4;
630
631 $_->join for (@a_trs, @a_res, @a_png);
632
633 print "scanning done, processing results...\n" if $VERBOSE;
634 {
635 # remove path prefix from editor_folder
636 substr $_->{editor_folder}, 0, 1 + length $path, ""
637 for values %ARC;
638
639 print "resolving inheritance tree...\n" if $VERBOSE;
640 # resolve inherit
641 while () {
642 my $progress;
643 my $loop;
644
645 for my $o (values %ARC) {
646 if (my $other = $o->{inherit}) {
647 if (my $s = $ARC{$other}) {
648 if ($s->{inherit}) {
649 $loop = $s;
650 } else {
651 delete $o->{inherit};
652 my %s = %$s;
653 delete @s{qw(_name more name name_pl)};
654 %$o = ( %s, %$o );
655 ++$progress;
656 }
657 } else {
658 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
659 delete $ARC{$o->{_name}};
660 }
661 }
662 }
663
664 unless ($progress) {
665 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
666 if $loop;
667
668 last;
669 }
670 }
671
672 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
673 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
674
675 print "writing archetypes...\n" if $VERBOSE;
676 open my $fh, ">:utf8", "$DATADIR/archetypes~"
677 or die "$DATADIR/archetypes~: $!";
678 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
679 }
680
681 {
682 print "writing treasures...\n" if $VERBOSE;
683 open my $fh, ">:utf8", "$DATADIR/treasures~"
684 or die "$DATADIR/treasures~: $!";
685 print $fh $TRS;
686 }
687
688 {
689 print "processing facedata...\n" if $VERBOSE;
690 while (my ($k, $v) = each %FACEINFO) {
691 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
692 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
693
694 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
695 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
696
697 if (my $magicmap = $v->{magicmap}) {
698 $magicmap =~ y/A-Z_\-/a-z/d;
699 $v->{magicmap} = $COLOR{$magicmap};
700 }
701
702 delete $v->{arc};
703 }
704
705 print "writing facedata...\n" if $VERBOSE;
706 open my $fh, ">:perlio", "$DATADIR/facedata~"
707 or die "$DATADIR/facedata~: $!";
708
709 print $fh freeze {
710 version => 2,
711 faceinfo => \%FACEINFO,
712 animinfo => \%ANIMINFO,
713 resource => \%RESOURCE,
714 };
715 }
716
717 print "committing files...\n" if $VERBOSE;
718
719 for (qw(archetypes facedata treasures)) {
720 chmod 0644, "$DATADIR/$_~";
721 rename "$DATADIR/$_~", "$DATADIR/$_"
722 or die "$DATADIR/$_: $!";
723 }
724
725 print "archetype data installed successfully.\n";
726 }
727 }
728
729 Getopt::Long::Configure ("bundling", "no_ignore_case");
730 GetOptions (
731 "verbose|v:+" => \$VERBOSE,
732 "cache" => \$CACHE,
733 "quiet|q" => sub { $VERBOSE = 0 },
734 "force" => sub { $FORCE = 1 },
735 "install-arch=s" => \&inst_arch,
736 "install-maps=s" => \&inst_maps,
737 "print-statedir" => sub { print "@pkgstatedir@\n" },
738 "print-datadir" => sub { print "$DATADIR\n" },
739 "print-confdir" => sub { print "@pkgconfdir@\n" },
740 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
741 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
742 ) or usage;
743